diff --git a/gcc/analyzer/supergraph.h b/gcc/analyzer/supergraph.h
index f887998..3b7bf70 100644
--- a/gcc/analyzer/supergraph.h
+++ b/gcc/analyzer/supergraph.h
@@ -114,6 +114,18 @@ public:
 	      (m_cgraph_edge_to_return_superedge).get (edge));
   }
 
+  cfg_superedge *get_edge_for_cfg_edge (edge e) const
+  {
+    return (*const_cast <cfg_edge_to_cfg_superedge_t &>
+	      (m_cfg_edge_to_cfg_superedge).get (e));
+  }
+
+  supernode *get_supernode_for_stmt (const gimple *stmt) const
+  {
+    return (*const_cast <stmt_to_node_t &>(m_stmt_to_node_t).get
+	    (const_cast <gimple *> (stmt)));
+  }
+
   void dump_dot_to_pp (pretty_printer *pp, enum supergraph_dot_flags flags,
 		       const dot_annotator *a = NULL) const;
   void dump_dot_to_file (FILE *fp, enum supergraph_dot_flags flags,
@@ -132,7 +144,7 @@ public:
 private:
   supernode *add_node (function *fun, basic_block bb, gcall *returning_call,
 		       gimple_seq phi_nodes);
-  superedge *add_cfg_edge (supernode *src, supernode *dest, ::edge e, int idx);
+  cfg_superedge *add_cfg_edge (supernode *src, supernode *dest, ::edge e, int idx);
   call_superedge *add_call_superedge (supernode *src, supernode *dest,
 				      cgraph_edge *cedge);
   return_superedge *add_return_superedge (supernode *src, supernode *dest,
@@ -141,8 +153,8 @@ private:
 
   /* Data.  */
 
-  auto_vec<supernode *> m_nodes;
-  auto_vec<superedge *> m_edges;
+  auto_delete_vec<supernode> m_nodes;
+  auto_delete_vec<superedge> m_edges;
 
   typedef hash_map<basic_block, supernode *> bb_to_node_t;
   bb_to_node_t m_bb_to_initial_node;
@@ -152,6 +164,10 @@ private:
   cgraph_edge_to_node_t m_cgraph_edge_to_caller_prev_node;
   cgraph_edge_to_node_t m_cgraph_edge_to_caller_next_node;
 
+  typedef hash_map<::edge, cfg_superedge *>
+    cfg_edge_to_cfg_superedge_t;
+  cfg_edge_to_cfg_superedge_t m_cfg_edge_to_cfg_superedge;
+
   typedef hash_map<cgraph_edge *, call_superedge *>
     cgraph_edge_to_call_superedge_t;
   cgraph_edge_to_call_superedge_t m_cgraph_edge_to_call_superedge;
@@ -159,6 +175,9 @@ private:
   typedef hash_map<cgraph_edge *, return_superedge *>
     cgraph_edge_to_return_superedge_t;
   cgraph_edge_to_return_superedge_t m_cgraph_edge_to_return_superedge;
+
+  typedef hash_map<gimple *, supernode *> stmt_to_node_t;
+  stmt_to_node_t m_stmt_to_node_t;
 };
 
 /* FIXME.  */
@@ -222,13 +241,16 @@ class supernode
     return dyn_cast<gcall *> (stmt);
   }
 
-  function *m_fun; // alternatively could be stored as runs of indices within the supergraph
-  basic_block m_bb;
-  gcall *m_returning_call; // for handling the result of a returned call
+  unsigned int get_stmt_index (const gimple *stmt) const;
+
+  function * const m_fun; // alternatively could be stored as runs of indices within the supergraph
+  const basic_block m_bb;
+  gcall * const m_returning_call; // for handling the result of a returned call
   gimple_seq m_phi_nodes; // ptr to that of the underlying BB, for the first supernode for the BB
   auto_vec<gimple *> m_stmts;
+  auto_vec<superedge *> m_preds;
   auto_vec<superedge *> m_succs;
-  int m_index; /* unique within the supergraph as a whole.  */
+  const int m_index; /* unique within the supergraph as a whole.  */
 };
 
 /* FIXME.  */
@@ -236,6 +258,8 @@ class supernode
 class superedge
 {
  public:
+  virtual ~superedge () {}
+
   void dump_dot (graphviz_out *gv, enum supergraph_dot_flags flags) const;
 
   virtual void dump_label_to_pp (pretty_printer *pp) const = 0;
@@ -262,9 +286,9 @@ class superedge
   {}
 
  public:
-  supernode *m_src;
-  supernode *m_dest;
-  enum edge_kind m_kind;
+  supernode *const m_src;
+  supernode *const m_dest;
+  const enum edge_kind m_kind;
 };
 
 /* A subclass of superedge corresponding to a callgraph edge.  */
@@ -280,6 +304,8 @@ class callgraph_superedge : public superedge
 
   void dump_label_to_pp (pretty_printer *pp) const OVERRIDE;
 
+  function *get_callee_function () const;
+  function *get_caller_function () const;
   tree get_callee_decl () const;
   tree get_caller_decl () const;
   gcall *get_call_stmt () const { return m_cedge->call_stmt; }
@@ -288,7 +314,7 @@ class callgraph_superedge : public superedge
   tree map_expr_from_caller_to_callee (tree caller_expr) const;
   tree map_expr_from_callee_to_caller (tree callee_expr) const;
 
-  cgraph_edge *m_cedge;
+  cgraph_edge *const m_cedge;
 };
 
 class call_superedge : public callgraph_superedge
@@ -367,10 +393,11 @@ class cfg_superedge : public superedge
   int get_flags () const { return m_cfg_edge->flags; }
   int true_value_p () const { return get_flags () & EDGE_TRUE_VALUE; }
   int false_value_p () const { return get_flags () & EDGE_FALSE_VALUE; }
+  int back_edge_p () const { return get_flags () & EDGE_DFS_BACK; }
 
   tree get_phi_arg (const gphi *phi) const;
 
-  ::edge m_cfg_edge;
+  const ::edge m_cfg_edge;
 };
 
 /* A subclass for edges from switch statements, retaining enough
@@ -394,7 +421,7 @@ class switch_cfg_superedge : public cfg_superedge {
   tree get_case_label () const;
 
  private:
-  int m_idx;
+  const int m_idx;
 };
 
 /* Base class for adding additional content to the .dot output
diff --git a/gcc/builtins.def b/gcc/builtins.def
index 1def29d..f1c7687 100644
--- a/gcc/builtins.def
+++ b/gcc/builtins.def
@@ -1104,4 +1104,7 @@ DEF_BUILTIN (BUILT_IN_ANALYZER_DUMP, "__analyzer_dump", BUILT_IN_NORMAL, BT_FN_V
 DEF_BUILTIN (BUILT_IN_ANALYZER_EVAL, "__analyzer_eval", BUILT_IN_NORMAL, BT_FN_VOID_INT, BT_LAST,
 	     false, false, false, ATTR_NULL, true, true)
 
+DEF_BUILTIN (BUILT_IN_ANALYZER_BREAK, "__analyzer_break", BUILT_IN_NORMAL, BT_FN_VOID, BT_LAST,
+	     false, false, false, ATTR_NULL, true, true)
+
 #undef DEF_BUILTIN
diff --git a/gcc/common.opt b/gcc/common.opt
index c59063d..19f54d7 100644
--- a/gcc/common.opt
+++ b/gcc/common.opt
@@ -541,6 +541,54 @@ Waggressive-loop-optimizations
 Common Var(warn_aggressive_loop_optimizations) Init(1) Warning
 Warn if a loop with constant number of iterations triggers undefined behavior.
 
+Wanalyzer-double-fclose
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-double-free
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-exposure-through-output-file
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-file-leak
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-free-of-non-heap
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-malloc-leak
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-possible-null-argument
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-possible-null-dereference
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-null-argument
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-null-dereference
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-tainted-array-index
+Common Init(1) Warning
+FIXME
+
+Wanalyzer-use-after-free
+Common Init(1) Warning
+FIXME
+
 Warray-bounds
 Common Var(warn_array_bounds) Warning
 Warn if an array is accessed out of bounds.
@@ -1000,6 +1048,10 @@ fanalyzer-impl=
 Common Joined RejectNegative UInteger Var(flag_analyzer_impl)
 FIXME
 
+fanalyzer-state-purge
+Common Var(flag_analyzer_state_purge) Init(1)
+FIXME
+
 fargument-alias
 Common Ignore
 Does nothing. Preserved for backward compatibility.
@@ -1378,6 +1430,12 @@ Common RejectNegative Var(flag_dump_analyzer)
 fdump-analyzer-summaries
 Common RejectNegative Var(flag_dump_analyzer_summaries)
 
+fdump-analyzer-supergraph
+Common RejectNegative Var(flag_dump_analyzer_supergraph)
+
+fdump-analyzer-exploded-graph
+Common RejectNegative Var(flag_dump_analyzer_exploded_graph)
+
 fanalyzer-verbosity=
 Common Joined UInteger Var(analyzer_verbosity) Init(1)
 FIXME
@@ -1386,6 +1444,10 @@ fanalyzer-verbose-state-changes
 Common Var(flag_analyzer_verbose_state_changes) Init(0)
 FIXME
 
+fanalyzer-region-model
+Common Var(flag_analyzer_region_model) Init(0)
+FIXME
+
 fdump-final-insns
 Driver RejectNegative
 
diff --git a/gcc/diagnostic-core.h b/gcc/diagnostic-core.h
index 0770ac7..2e7f120 100644
--- a/gcc/diagnostic-core.h
+++ b/gcc/diagnostic-core.h
@@ -81,8 +81,9 @@ extern bool warning_at (location_t, int, const char *, ...)
     ATTRIBUTE_GCC_DIAG(3,4);
 extern bool warning_at (rich_location *, int, const char *, ...)
     ATTRIBUTE_GCC_DIAG(3,4);
-extern bool warning_at (rich_location *, const diagnostic_metadata &, const char *, ...)
-    ATTRIBUTE_GCC_DIAG(3,4);
+extern bool warning_at (rich_location *, const diagnostic_metadata &, int,
+			const char *, ...)
+    ATTRIBUTE_GCC_DIAG(4,5);
 extern void error (const char *, ...) ATTRIBUTE_GCC_DIAG(1,2);
 extern void error_n (location_t, unsigned HOST_WIDE_INT, const char *,
 		     const char *, ...)
@@ -114,7 +115,7 @@ extern bool emit_diagnostic (diagnostic_t, rich_location *, int,
 			     const char *, ...) ATTRIBUTE_GCC_DIAG(4,5);
 extern bool emit_diagnostic_valist (diagnostic_t, location_t, int, const char *,
 				    va_list *) ATTRIBUTE_GCC_DIAG (4,0);
-extern bool emit_diagnostic_valist (diagnostic_t, rich_location *, 
+extern bool emit_diagnostic_valist (diagnostic_t, rich_location *,
 				    const diagnostic_metadata *metadata,
 				    int, const char *, va_list *)
   ATTRIBUTE_GCC_DIAG (5,0);
diff --git a/gcc/diagnostic.c b/gcc/diagnostic.c
index 4a5f1b44..0468325 100644
--- a/gcc/diagnostic.c
+++ b/gcc/diagnostic.c
@@ -1438,7 +1438,7 @@ warning_at (rich_location *richloc, int opt, const char *gmsgid, ...)
 
 bool
 warning_at (rich_location *richloc, const diagnostic_metadata &metadata,
-	    const char *gmsgid, ...)
+	    int opt, const char *gmsgid, ...)
 {
   gcc_assert (richloc);
 
@@ -1446,7 +1446,7 @@ warning_at (rich_location *richloc, const diagnostic_metadata &metadata,
   va_list ap;
   va_start (ap, gmsgid);
   bool ret
-    = diagnostic_impl (richloc, &metadata, 0, gmsgid, &ap,
+    = diagnostic_impl (richloc, &metadata, opt, gmsgid, &ap,
 		       DK_WARNING);
   va_end (ap);
   return ret;
diff --git a/gcc/function-tests.c b/gcc/function-tests.c
index f1e29e4..394a5ef 100644
--- a/gcc/function-tests.c
+++ b/gcc/function-tests.c
@@ -82,11 +82,11 @@ namespace selftest {
 
 /* Helper function for selftests of function-creation.  */
 
-static tree
+tree
 make_fndecl (tree return_type,
 	     const char *name,
 	     vec <tree> &param_types,
-	     bool is_variadic = false)
+	     bool is_variadic)
 {
   tree fn_type;
   if (is_variadic)
diff --git a/gcc/selftest.h b/gcc/selftest.h
index 88dc951..8d08843 100644
--- a/gcc/selftest.h
+++ b/gcc/selftest.h
@@ -170,6 +170,13 @@ class line_table_test
   ~line_table_test ();
 };
 
+/* FIXME.  */
+
+extern tree make_fndecl (tree return_type,
+			 const char *name,
+			 vec <tree> &param_types,
+			 bool is_variadic = false);
+
 /* Run TESTCASE multiple times, once for each case in our test matrix.  */
 
 extern void
diff --git a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-1.c b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-1.c
new file mode 100644
index 0000000..585a06f
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-1.c
@@ -0,0 +1,12 @@
+/* { dg-additional-options "-fanalyzer-region-model" } */
+
+void test_1 (void)
+{
+  int x, y;
+  int *p = &x;
+  x = 3;
+  *p = 4;
+  y = x;
+
+  __analyzer_eval (y == 4); /* { dg-warning "TRUE" } */
+}
diff --git a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-2.c b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-2.c
new file mode 100644
index 0000000..93e7f1a
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-2.c
@@ -0,0 +1,19 @@
+/* { dg-additional-options "-fanalyzer-region-model" } */
+
+#include <stdlib.h>
+
+void test_2 (void)
+{
+  void *p = malloc (10);
+  char *buf1 = (char*)p;
+  buf1[0] = 'a'; /* { dg-warning "use of possibly-NULL 'buf1'" } */
+
+  int *buf2 = (int*)p;
+  buf2[0] = 0;
+
+  char c = buf1[0];
+
+  __analyzer_eval (c == 0); /* { dg-warning "TRUE" } */
+
+  free (p);
+}
diff --git a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-3.c b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-3.c
new file mode 100644
index 0000000..5310c38
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-3.c
@@ -0,0 +1,24 @@
+/* { dg-additional-options "-fanalyzer-region-model" } */
+
+#include <stdlib.h>
+
+struct s1
+{
+  int d;
+};
+struct s2
+{
+  struct s1 *p;
+};
+void test_3 (void)
+{
+  struct s1 data;
+  struct s2 *sp;
+  int a[2];
+  sp = malloc(sizeof(struct s2));
+  sp->p = &data; /* { dg-warning "use of possibly-NULL 'sp'" } */
+  sp->p->d = 3;
+  a[1] = data.d;
+  __analyzer_eval (a[1] == 3); /* { dg-warning "TRUE" } */
+
+} /* { dg-warning "leak of 'sp'" } */
diff --git a/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-4.c b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-4.c
new file mode 100644
index 0000000..818166c
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-4.c
@@ -0,0 +1,31 @@
+/* { dg-additional-options "-fanalyzer-region-model" } */
+
+#include <stddef.h>
+
+struct s { int data[2]; };
+void test_4 (struct s buf)
+{
+  int i = 3, *q = NULL;
+  struct s* p;
+  if (buf.data[1] == 1)
+    q = &i;
+  p = &buf;
+  if (p->data[1] == 1)
+    p->data[0] = *q; /* { dg-bogus "use of NULL 'q'" } */
+  return;
+}
+
+/* To avoid a false positive read-through-uninit at *q, we need to handle
+   phi nodes, and to enforce constraints.
+
+   region_model's constraint model is now good enough to rule out
+   the path as infeasible.
+
+   Looks like at the first:
+
+     if (buf.data[1] == 1)
+
+   we have an unknown value for buf.data[1], but it's the unknown
+   value for "buf" as a whole; we should have created unknown values
+   for the child (or for accesses to the parent unknown value).  */
+
diff --git a/gcc/testsuite/gcc.dg/analyzer/abort.c b/gcc/testsuite/gcc.dg/analyzer/abort.c
index cfbf74c..285a4c7 100644
--- a/gcc/testsuite/gcc.dg/analyzer/abort.c
+++ b/gcc/testsuite/gcc.dg/analyzer/abort.c
@@ -1,3 +1,5 @@
+/* { dg-additional-options "-fanalyzer-region-model" } */
+
 #include <assert.h>
 #include <stdio.h>
 #include <stdlib.h>
diff --git a/gcc/testsuite/gcc.dg/analyzer/alloca-leak.c b/gcc/testsuite/gcc.dg/analyzer/alloca-leak.c
new file mode 100644
index 0000000..6d9fe34
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/analyzer/alloca-leak.c
@@ -0,0 +1,8 @@
+#include <alloca.h>
+
+void *test (void)
+{
+  void *ptr = alloca (64);
+  return ptr;
+}
+/* TODO: warn about escaping alloca.  */
diff --git a/gcc/testsuite/gcc.dg/analyzer/attribute-nonnull.c b/gcc/testsuite/gcc.dg/analyzer/attribute-nonnull.c
new file mode 100644
index 0000000..ab44d07
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/analyzer/attribute-nonnull.c
@@ -0,0 +1,57 @@
+#include <stdlib.h>
+
+extern void foo(void *ptrA, void *ptrB, void *ptrC) /* { dg-message "argument 1 of 'foo' must be non-null" } */
+  __attribute__((nonnull (1, 3)));
+
+extern void bar(void *ptrA, void *ptrB, void *ptrC) /* { dg-message "argument 1 of 'bar' must be non-null" } */
+  __attribute__((nonnull));
+
+// TODO: complain about NULL and possible NULL args
+// FIXME: ought to complain about NULL args
+
+void test_1 (void *p, void *q, void *r)
+{
+  foo(p, q, r);
+  foo(NULL, q, r);
+  foo(p, NULL, r);
+  foo(p, q, NULL);
+}
+
+void test_1a (void *q, void *r)
+{
+  void *p = NULL;
+  foo(p, q, r); /* { dg-warning "use of NULL 'p' where non-null expected" } */
+  /* { dg-message "argument 1 \\('p'\\) NULL where non-null expected" "" { target *-*-* } .-1 } */
+}
+
+void test_2 (void *p, void *q, void *r)
+{
+  bar(p, q, r);
+  bar(NULL, q, r);
+  bar(p, NULL, r);
+  bar(p, q, NULL);
+}
+
+void test_3 (void *q, void *r)
+{
+  void *p = malloc(1024); /* { dg-message "this call could return NULL" } */
+
+  foo(p, q, r); /* { dg-warning "use of possibly-NULL 'p' where non-null expected" } */
+  /* { dg-message "argument 1 \\('p'\\) could be NULL where non-null expected" "" { target *-*-* } .-1 } */
+
+  foo(p, q, r);
+
+  free(p);
+}
+
+void test_4 (void *q, void *r)
+{
+  void *p = malloc(1024); /* { dg-message "this call could return NULL" } */
+
+  bar(p, q, r); /* { dg-warning "use of possibly-NULL 'p' where non-null expected" } */
+  /* { dg-message "argument 1 \\('p'\\) could be NULL where non-null expected" "" { target *-*-* } .-1 } */
+
+  bar(p, q, r);
+
+  free(p);
+}
diff --git a/gcc/testsuite/gcc.dg/analyzer/conditionals.c b/gcc/testsuite/gcc.dg/analyzer/conditionals.c
index 578a9b8..28f6978 100644
--- a/gcc/testsuite/gcc.dg/analyzer/conditionals.c
+++ b/gcc/testsuite/gcc.dg/analyzer/conditionals.c
@@ -1,3 +1,5 @@
+/* { dg-additional-options "-fanalyzer-region-model" } */
+
 void test (int i, int j)
 {
   if (i > 4)
